searchData={"items":[{"type":"module","doc":"For testing only","title":"Blog","ref":"Blog.html"},{"type":"function","doc":"","title":"Blog.fetch_post/1","ref":"Blog.html#fetch_post/1"},{"type":"function","doc":"Gets a specific post by the id (slug)","title":"Blog.get_post/1","ref":"Blog.html#get_post/1"},{"type":"function","doc":"Returns a list of all the posts","title":"Blog.list_posts/0","ref":"Blog.html#list_posts/0"},{"type":"function","doc":"Returns a list of posts for the page, accepts page as integer or string","title":"Blog.list_posts/1","ref":"Blog.html#list_posts/1"},{"type":"function","doc":"Gets a list of all the tags","title":"Blog.list_tags/0","ref":"Blog.html#list_tags/0"},{"type":"function","doc":"Number of pages of posts","title":"Blog.pages/0","ref":"Blog.html#pages/0"},{"type":"function","doc":"Returns a list of all the posts with a tag","title":"Blog.posts_tagged_with/1","ref":"Blog.html#posts_tagged_with/1"},{"type":"function","doc":"Returns a map with the tags as keys and the frequency as a value","title":"Blog.tags_with_count/0","ref":"Blog.html#tags_with_count/0"},{"type":"module","doc":"Postex is a simple static blog generator using markdown files that is inspired/copied from\n[Dashbit's blog post](https://dashbit.co/blog/welcome-to-our-blog-how-it-was-made).\n\nSee the README for more details!","title":"Postex","ref":"Postex.html"},{"type":"module","doc":"Performs code highlighting. Stolen shamelessly from ex_doc","title":"Postex.Highlighter","ref":"Postex.Highlighter.html"},{"type":"function","doc":"Highlights all code block in an already generated HTML document.","title":"Postex.Highlighter.highlight_code_blocks/2","ref":"Postex.Highlighter.html#highlight_code_blocks/2"},{"type":"module","doc":"A tickle trunk full of all the extra little things","title":"Postex.MetaData","ref":"Postex.MetaData.html"},{"type":"function","doc":"Add the top three related posts, scored based on how many of the same tags they have.","title":"Postex.MetaData.add_related_posts/1","ref":"Postex.MetaData.html#add_related_posts/1"},{"type":"function","doc":"","title":"Postex.MetaData.add_related_posts/2","ref":"Postex.MetaData.html#add_related_posts/2"},{"type":"module","doc":"An individual blog post","title":"Postex.Post","ref":"Postex.Post.html"},{"type":"function","doc":"","title":"Postex.Post.parse!/2","ref":"Postex.Post.html#parse!/2"},{"type":"type","doc":"","title":"Postex.Post.t/0","ref":"Postex.Post.html#t:t/0"},{"type":"module","doc":"For validating at compile time","title":"Postex.Validate","ref":"Postex.Validate.html"},{"type":"function","doc":"Raises if there are any duplicate slugs","title":"Postex.Validate.no_duplicate_slugs/1","ref":"Postex.Validate.html#no_duplicate_slugs/1"},{"type":"function","doc":"Raises unless the prefix is set for the use Macro, i.e.\n\n```\nuse Postex, prefix: \"https://www.yoursite.com/posts/\"\n```\n\nor is explicitly disabled, i.e.\n\n```\nuse Postex, prefix: false\n```","title":"Postex.Validate.prefix_defined/1","ref":"Postex.Validate.html#prefix_defined/1"},{"type":"function","doc":"","title":"Postex.Validate.same_data_fields/1","ref":"Postex.Validate.html#same_data_fields/1"},{"type":"function","doc":"Raises unless all urls (prefix + slug) are less than 60 characters (for SEO) as per [Neil Patel](https://neilpatel.com/blog/seo-urls/).\n\n  Feature can be disabled by setting prefix to `false`","title":"Postex.Validate.url_length/2","ref":"Postex.Validate.html#url_length/2"},{"type":"extras","doc":"# Postex\n\n[![Build Status](https://github.com/alanvardy/postex/workflows/Unit%20Tests/badge.svg)](https://github.com/alanvardy/postex)\n[![Build Status](https://github.com/alanvardy/postex/workflows/Dialyzer/badge.svg)](https://github.com/alanvardy/postex)\n[![hex.pm](http://img.shields.io/hexpm/v/postex.svg?style=flat)](https://hex.pm/packages/postex)\n[![codecov](https://codecov.io/gh/alanvardy/exzeitable/branch/master/graph/badge.svg?token=P3O42SF7VJ)](https://codecov.io/gh/alanvardy/exzeitable)\n\nPostex is a simple static blog generator using markdown files that was inspired/shamelessly copied from [Dashbit's blog post](https://dashbit.co/blog/welcome-to-our-blog-how-it-was-made).\n\nThe posts are generated at compile time, and syntax highlighting works well. Earmark is used\nfor markdown parsing and makeup_elixir / stolen ex_doc code for syntax highlighting. Phoenix_html is pulled in for a single protocol implementation.\n\nThis library just provides the context. The routes, views, controllers and templates are still in your hands.\n\nMost of this work is not my own, all credit to Dashbit and José Valim.\n\nDocumentation can be found at [https://hexdocs.pm/postex](https://hexdocs.pm/postex).\n\nThis library is in use at [alanvardy.com](https://www.alanvardy.com/) ([GitHub](https://github.com/alanvardy/alan_vardy))","title":"Postex","ref":"README.html"},{"type":"extras","doc":"- Posts are generated at compile time (fast access, no database required)\n- Posts live update as you edit them.\n- Posts have tags\n- Elixir syntax highlighting\n- You can add as many additional fields as you want, they can be found under `:data` and are represented as a map.\n- Includes 5 related posts (determined based on how many tags they share) as an association for each post\n- Easy image handling (see below)","title":"Features - Postex","ref":"README.html#features"},{"type":"extras","doc":"- Post url does not exceed 60 characters (for SEO - can be disabled)\n- No duplicate slugs (post ids)\n- All field keys are consistent across all posts (including within the data field)","title":"Compile Time Checks - Postex","ref":"README.html#compile-time-checks"},{"type":"extras","doc":"Assuming that you `use Postex` in a module named `Blog`, your API is:\n\n### `Blog.list_posts/0`\n\nLists all the posts\n\n### `Blog.list_posts/1`\n\nWith a given page, lists the posts for that page (default posts per page is 10)\n\n### `Blog.posts_tagged_with/1`\n\nPass it a single tag and it will return a list of the posts with that tag\n\n### `Blog.get_post/1`\n\nGet a post by id (slug), returns `nil` if not found,\n\n### `Blog.fetch_post/1`\n\nGet a post by id (slug), returns `{:ok, post}` or `{:error, :not_found}`\n  \n### `Blog.list_tags/0`\n\nLists all the tags\n\n### `Blog.tags_with_count/0`\n\nReturns a map where the string keys are the tags, and values are integers representing the frequency of their appearance.","title":"Usage - Postex","ref":"README.html#usage"},{"type":"extras","doc":"This library requires `Elixir >= 1.10`\n\nAdd `postex` to your list of dependencies in `mix.exs`:\n\n```elixir\n# mix.exs\n\ndef deps do\n  [\n    {:postex, \"~> 0.1.8\"}\n  ]\nend\n```\n\nCreate a module and `use Postex` within it.\n\n```elixir\ndefmodule YourApp.Blog do\n  @moduledoc \"The blog context\"\n  use Postex, \n    prefix: \"https://exampleblog.com/posts/\", # required\n    external_links_new_tab: true, # default\n    per_page: 10 # default\nend\n```\n\nAdd markdown file patterns to your Endpoint config in `config/dev.exs` for live reloading.\n\n```elixir\n# dev.exs\n\nconfig :your_app, YourAppWeb.Endpoint,\n  live_reload: [\n    patterns: [\n      ... the other patterns ...\n      ~r\"posts/*/.*(md)$\"\n    ]\n  ]\n```\n\nAnd add some routes\n\n```elixir\n# router.ex\n\nget \"/blog\", YourAppWeb.PostController, :index\nresources \"/post\", YourAppWeb.PostController, only: [:show]\nresources \"/tag\", YourAppWeb.TagController, only: [:index, :show]\n```\n\nAnd build out your controllers, views, and templates.\n\nCheck `CSS.md` for an example on styling the HTML output.","title":"Installation - Postex","ref":"README.html#installation"},{"type":"extras","doc":"Store markdown files with the path `/blog/{year}/{month}-{day}-{slug}.md`\n\nFor example `/blog/2020/03-17-this-is-a-blog-slug.md`\n\nFormat your markdown file like so\n\n```markdown\n==title==\nYour Title Goes Here\n\n==author==\nYour name probably\n\n==description==\nMore text and stuff\n\n==tags==\nseparate,your_tags,with,commas\n\n==body==\n\n# This is a title\n\n![alt text](picture.jpg \"Awesome picture\")\n\nThis is a paragraph\n\n```","title":"Adding Templates and Pictures - Postex","ref":"README.html#adding-templates-and-pictures"},{"type":"extras","doc":"External links (identified by beginning with `http`) are automatically appended with `target: \"_blank\"` to make the link open in a new tab.\n\nYou can disable this functionality with\n\n```elixir\ndefmodule YourApp.Blog do\n  @moduledoc \"The blog context\"\n  use Postex, \n    prefix: \"https://exampleblog.com/posts/\",\n    external_links_new_tab: false\nend\n```","title":"External links - Postex","ref":"README.html#external-links"},{"type":"extras","doc":"Store your images in the path `/priv/static/images/blog/{year}/{picture.jpg}` and reference them by the filename only (as seen in the example above).","title":"Storing images - Postex","ref":"README.html#storing-images"},{"type":"extras","doc":"If you wish to implement pagination, check out the [GitHub repository for alanvardy.com](https://github.com/alanvardy/alan_vardy) for examples of how I put it together.","title":"Pagination - Postex","ref":"README.html#pagination"},{"type":"extras","doc":"You may have occasional issues getting a markdown file recognized after being added or renamed, in this case run `mix compile --force`.","title":"Recompiling - Postex","ref":"README.html#recompiling"},{"type":"extras","doc":"I welcome contributions, but please check with me before starting on a pull request - I would hate to have your efforts be in vain.","title":"Contributing - Postex","ref":"README.html#contributing"},{"type":"extras","doc":"# Changelog","title":"Changelog","ref":"CHANGELOG.html"},{"type":"extras","doc":"","title":"Unreleased - Changelog","ref":"CHANGELOG.html#unreleased"},{"type":"extras","doc":"- Update Elixir/Erlang versions\n- Update dependencies","title":"v0.1.9 (2024-12-20) - Changelog","ref":"CHANGELOG.html#v0-1-9-2024-12-20"},{"type":"extras","doc":"- Enforce no spaces in tags with a clear error message\n- Update GitHub cache action to v2\n- Update asset path in instructions\n- Update Elixir and OTP versions","title":"v0.1.8 (2022-09-04) - Changelog","ref":"CHANGELOG.html#v0-1-8-2022-09-04"},{"type":"extras","doc":"- Update Elixir and Erlang versions\n- Use new GitHub action for building Elixir/Erlang\n- Update dependencies","title":"v0.1.7 (2021-01-24) - Changelog","ref":"CHANGELOG.html#v0-1-7-2021-01-24"},{"type":"extras","doc":"- Update dependencies.","title":"v0.1.6 (2020-10-14) - Changelog","ref":"CHANGELOG.html#v0-1-6-2020-10-14"},{"type":"extras","doc":"- Update dependencies.","title":"v0.1.5 (2020-8-13) - Changelog","ref":"CHANGELOG.html#v0-1-5-2020-8-13"},{"type":"extras","doc":"- Update dependencies.\n- Fix tests to match slightly different outputs.","title":"v0.1.4 (2020-8-11) - Changelog","ref":"CHANGELOG.html#v0-1-4-2020-8-11"},{"type":"extras","doc":"- All external links (identified by beginning with `http`) open in a new tab\n- Added `external_links_new_tab` option when using Postex, defaults to `true`\n- Added `list_posts/1` and `pages/0` for paginating posts\n- Added `per_pages` option when using Postex, defaults to `10`","title":"v0.1.3 (2020-3-12) - Changelog","ref":"CHANGELOG.html#v0-1-3-2020-3-12"},{"type":"extras","doc":"- Added `related_posts` association to posts, listing the top 5 related posts based on tags.\n- Custom fields can be added to the markdown file - and appear under the `data` key as a map.\n- Validates that fields under the data key are consistent across posts.","title":"v0.1.2 (2020-2-26) - Changelog","ref":"CHANGELOG.html#v0-1-2-2020-2-26"},{"type":"extras","doc":"- Breaking change: Need to define prefix in a use statement or explicitly set to false\n- Verify URL with slug does not exceed 60 characters\n- Check for duplicate slugs and raise errors if found.","title":"v0.1.1 (2020-2-26) - Changelog","ref":"CHANGELOG.html#v0-1-1-2020-2-26"},{"type":"extras","doc":"- Initial release","title":"v0.1.0 (2020-2-18) - Changelog","ref":"CHANGELOG.html#v0-1-0-2020-2-18"},{"type":"extras","doc":"# Adding CSS to your post\n\nHere is a part of my SASS file to get you started. I initially used Bootstrap 4; if you use a different framework or vanilla CSS, you need to replace the `@extend`s with something else.\n\n```css\n// I wrap the HTML output in .blog-body\n.blog-body {\n  @extend .bg-white;\n  @extend .text-black;\n  @extend .my-4;\n  @extend .rounded;\n  @extend .p-5;\n  @extend .shadow;\n}\n\n// Headings\n\n.blog-body > h3 {\n  margin-top: 2rem;\n  @extend .text-primary;\n}\n\n// Pictures\n\n.blog-body > p > img {\n  @extend .w-50;\n  @extend .d-block;\n  @extend .mx-auto;\n  @extend .rounded;\n  @extend .shadow;\n  @extend .my-4;\n}\n\n// Syntax Highlighting\n\npre {\n  background-color: rgb(36, 40, 46);\n  @extend .p-3;\n  @extend .rounded;\n  @extend .shadow;\n  @extend .m-3\n}\n\n.kd, .k {color: rgb(219, 112, 219);}\n.nc, .p {color: rgb(241, 224, 63);}\n.sr, .se, .nf, .kn{color: rgb(146, 195, 235)}\n.s, .c {color: rgb(128, 128, 128)}\n.na, .ni {color: rgb(194, 62, 62);}\n.n, .o, .no {color: rgb(231, 231, 231)}\n.ss {color: rgb(59, 212, 205)}\n```","title":"Adding CSS to your post","ref":"CSS.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}